Attribute VB_Name = "MISCPROC"
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'                                MISCPROC.BAS                          '
'                 ODBC Visual Basic Sample Application                 '
'                                                                      '
' -- Copyright 1991, 1992 by Microsoft Corporation                     '                 '
'                                                                      '
' Uses ODBC drivers, June 1992 Spec                                    '
'                                                                      '
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Const NULL_POINTER = 0
Const MAX_WIDTH = 255
Const DefaultAllocSize = 256        ' Default allocation size

Dim ColWidth() As Integer           ' Width (in characters) of each column
Dim Retcode As Integer              ' ODBC Return Code

'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
Sub Attempt(ResultCode As Integer, ErrorMessage As String)
  ' If ResultCode <> SQL_SUCCESS, then exit
  
  If (ResultCode <> SQL_SUCCESS) Then
    Screen.MousePointer = Normal
    ErrorMessage = ErrorMessage & " RC: " & Str$(ResultCode)
    MsgBox ErrorMessage, StopIcon, "Unexpected ODBC Driver Function failure"
    Stop
  End If

End Sub


'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
Function BeginConnection()
  ' Attempt to make connection.  If successful, allocate statement
  ' handle and place connection tag in the list box
  Dim Tag As String * 30
  Dim Server As String * 100
  Dim i As Integer
  
  
  Screen.MousePointer = HourGlass
  Connection.Status = 0
  
  ' Allocate a connection handle
  Attempt SQLAllocConnect(henv, Connection.hdbc), "Cannot allocate connection handle"
  
  ' Make the connection
  rc% = SQLDriverConnect(Connection.hdbc, GetParent(GetFocus()), S$, Len(S$), Server, Len(Server), cbOut%, SQL_DRIVER_COMPLETE)
  If (rc% = SQL_ERROR) Or (rc% = SQL_INVALID_HANDLE) Then
    DescribeError Connection.hdbc, 0
    Screen.MousePointer = Normal
    BeginConnection = SQL_ERROR
    Exit Function
  ElseIf rc% = SQL_NO_DATA_FOUND Then
    Screen.MousePointer = Normal
    BeginConnection = SQL_ERROR
    Exit Function
  End If
  
  ' Allocate a statement handle
  Attempt SQLAllocStmt(Connection.hdbc, Connection.hstmt), "Cannot allocate statment handle"
 
  'We have a connection (Yay!)
  '  Check that the tag is not duplicate,
  '  Fix up globals, and
  '  Fix up the screen
  
  iPos1& = InStr(Server, ";")
  If (iPos1& < 4) Then
    Tag = "Connection" + Str$(1)
  Else
    Tag = Mid$(Server, 5, iPos1& - 5)
  End If
  

  Connection.Status = Active
  Connection.Tag = Tag

   frmMain.Status.Caption = "Successfully Connected to " & Tag
  
  
  If Connection.Status = Active Then
    frmMain.btnExecute.Enabled = True
    frmMain.optODBC.Enabled = True
    'QueryForm.RemoveConnectionMenuItem.Enabled = True
  End If

  BeginConnection = SQL_SUCCESS
  Screen.MousePointer = Normal
  'frmMain.Status.Caption = "Successfully Connected to " & RTrim$(Tag)
  'MsgBox "Connection to '" + RTrim$(Tag) + "' Established", InfoIcon, AppName

End Function


''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
Sub Cleanup()
  ' Terminate any unused connections
  'Dim i As Integer

  If Connection.Status = Active Then
     EndConnection
  End If
  
End Sub

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
Sub DescribeError(ByVal hdbc As Long, ByVal hstmt As Long)
  ' Print an error message for the given connection handle
  ' and statement handle
  Dim rgbValue1 As String * 16
  Dim rgbValue3 As String * SBufferLen
  Dim Outlen As Integer
  Dim Native As Long

  rgbValue1 = String$(16, 0)
  rgbValue3 = String$(SBufferLen, 0)
  
  Do
    rc = SQLError(henv, hdbc, hstmt, rgbValue1, Native, rgbValue3, SBufferLen, Outlen)
    Screen.MousePointer = Normal
    If rc = SQL_SUCCESS Or rc = SQL_SUCCESS_WITH_INFO Then
        If Outlen = 0 Then
            MsgBox "Error -- No error information available", AttIcon, AppName
        Else
            If Retcode = SQL_ERROR Then
                MsgBox Left$(rgbValue3, Outlen), StopIcon, AppName
            Else
                MsgBox Left$(rgbValue3, Outlen), AttIcon, AppName
            End If
        End If
    End If
  Loop Until rc <> SQL_SUCCESS

End Sub

'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
Sub EndConnection()
  ' Terminate the connection, deallocating statement and connection handles

  Attempt SQLFreeStmt(Connection.hstmt, SQL_CLOSE), "Unable to free statment handle"
  Attempt SQLDisconnect(Connection.hdbc), "Unable to disconnect"
  Attempt SQLFreeConnect(Connection.hdbc), "Unable to free connection handle"
  
  Connection.Status = Inactive
  
  'If NumConnections = 0 Then
  '  QueryForm.DBSelectCombo.Enabled = False
  frmMain.btnExecute.Enabled = False
  '  QueryForm.TablesBtn.Enabled = False
  '  QueryForm.DisconnectButton.Enabled = False
  '  QueryForm.RemoveConnectionMenuItem.Enabled = False
  'End If
  
  'MsgBox "Connection to '" + RTrim$(Connection.Tag) + "' Closed.", InfoIcon, AppName
  frmMain.Status.Caption = "Successfully Disconnected from " & RTrim$(Tag)
End Sub

'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
Sub FillForm(hdbc As Long, hstmt As Long, Query As String)
  ' Execute the given query, using the given hStmt,
  ' and place resulting data in the grid control
  ' If an error occurs, nothing happens
  Dim maxColWidth As Long, ColTypeCode As Integer, ColNullable As Integer
  Dim Outlen As Integer, pcbValue As Long
  Dim ColScale As Integer, i As Integer
  Dim NumRows, NumCols As Integer

  Dim rgbValue As String * SBufferLen
  Dim ValidColumn() As Integer
  Dim rgbValueLen As Integer
  Screen.MousePointer = HourGlass
  
  ' Execute the query
  'If Left$(Query, 1) = "T" Then
  '   Retcode = SQLTables(hstmt, NULL_POINTER, 0, NULL_POINTER, 0, NULL_POINTER, 0, NULL_POINTER, 0)
  'Else
  '   Retcode = SQLExecDirect(hstmt, Query, Len(Query))
  'End If
  'If Retcode <> SQL_SUCCESS Then
  '  DescribeError hdbc, hstmt
  '  screen.MousePointer = Normal
  '  Exit Sub
  'End If
  '
  '' Get the number of columns in the result set
  'Retcode = SQLNumResultCols(hstmt, NumCols)
  'If Retcode <> SQL_SUCCESS Then
  '  DescribeError hdbc, hstmt
  '  screen.MousePointer = Normal
  '  Exit Sub
  'End If
  '
  'If NumCols = 0 Then
  '  screen.MousePointer = Normal
  '  MsgBox "Query Executed.  No results returned", InfoIcon, AppName
  '  Exit Sub
  'End If
  '
  'ReDim ColWidth(NumCols + 1)
  'ReDim ValidColumn(NumCols + 1)
  '
  'For i = 0 To NumCols + 1
  '  ValidColumn(i) = True
  'Next i
  '
  'rgbValue = String$(rgbValueLen, 0)
  '
  '' Retrieve the metadata for each column in the result set
  '' and initialize the column widths of the grid.
  'QueryForm.DataGrid.Rows = 1
  'QueryForm.DataGrid.Cols = NumCols + 1
  'ColWidth(0) = 8 'Column zero is the row number column.  It is 8 characters wide.
  'For i = 1 To NumCols
  '  QueryForm.DataGrid.Col = i  'Move to current column
  '  Attempt SQLDescribeCol(hstmt, i, rgbValue, SBufferLen, Outlen, ColTypeCode, maxColWidth, ColScale, ColNullable), "DescribeCol Failed"
  '  QueryForm.DataGrid.Text = Left$(rgbValue, Outlen)
  '  If maxColWidth > MAX_WIDTH Then maxColWidth = MAX_WIDTH
  '  ColWidth(i) = maxColWidth  'Record the maximum text length for the column
  '
  '  'A beginning column width of 1500 was arbitrarily chosen.  The user can resize this.
  '  QueryForm.DataGrid.ColWidth(i) = 1500
  'Next i
  '
  ''Set up the grid for this result set
  'QueryForm.DataGrid.FixedRows = 0  'allow next step
  'QueryForm.DataGrid.Rows = 1       'clears the grid completely
  'QueryForm.DataGrid.Cols = NumCols + 1   'Set the new column count
  'rc = 1    'Set the row count to 1 (For Column Names)
  '
  'Do   'Repeat this loop until all result rows are fetched
  '  Retcode = SQLFetch(hstmt)
  '  If Retcode <> SQL_SUCCESS Then
  '    Exit Do
  '  End If
  '
  '  QueryForm.DataGrid.Rows = rc + 1  'Increment the row counter
  '  QueryForm.DataGrid.Row = rc       'and move to the next row
  '  QueryForm.DataGrid.Col = 0
  '  QueryForm.DataGrid.Text = CStr(rc + start)
  '
  '  For i = 1 To NumCols
  '    QueryForm.DataGrid.Col = i
  '    Retcode = SQLGetData(hstmt, i, SQL_C_CHAR, rgbValue, SBufferLen, pcbValue)
  '    If Retcode <> SQL_SUCCESS Then
  '      If ValidColumn(i) = True Then
  '        DescribeError hdbc, hstmt
  '        ValidColumn(i) = False
  '        If Retcode = SQL_ERROR Then
 '           MsgBox "Result Column " + Str$(i) + " will be ignored", AttIcon, AppName
 '         End If
 '       End If
  '    End If
 ''     If Retcode <> SQL_ERROR Then
   '     If pcbValue = SQL_NULL_DATA Then
   '       QueryForm.DataGrid.Text = "NULL"
   '     Else
   '       QueryForm.DataGrid.Text = Trim$(rgbValue)
   '     End If
   '   End If
   ' Next i
   '
   ' rc = rc + 1
  'L'oop

  'QueryForm.DataGrid.FixedRows = 1   'freeze the field names
  'QueryForm.DataGrid.FixedCols = 1   'freeze the row numbers
  '
  'QueryForm.DataGrid.Row = 1         'set current position
  'QueryForm.DataGrid.Col = 1
  'Attempt SQLFreeStmt(hstmt, SQL_CLOSE), "FreeStmt Failed"
  '
End Sub


'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
Function GetAllAscii(ByVal Headers As Integer) As String
  '  Like GetAscii, but returns entire contents of the grid buffer
  
  'GetAllAscii = GetAscii(Headers, 0, QueryForm.DataGrid.Rows - 1, 0, QueryForm.DataGrid.Cols - 1)

End Function

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
Function GetAllocSize() As Integer
  ' Returns the current size (in rows) of the grid buffer.
  
  If AllocSize = 0 Then
    AllocSize = DefaultAllocSize
  End If
  
  GetAllocSize = AllocSize

End Function

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
Function GetAscii(ByVal Headers As Integer, ByVal FirstRow As Integer, ByVal LastRow As Integer, ByVal FirstCol As Integer, ByVal LastCol As Integer) As String
  ' Returns an Ascii string containing a formatted representation
  ' of a portion of the grid buffer.  If Headers is TRUE, headers are
  ' also given.
  Dim i As Integer, j As Integer, w As Integer
  Dim text As String

  'Text = ""

  'For j = FirstRow To LastRow
    'QueryForm.DataGrid.Row = j
  '  For i = FirstCol To LastCol
  '    QueryForm.DataGrid.Col = i
  '    Text = Text + Trim$(QueryForm.DataGrid.Text)
  '    If (i < LastCol) Then Text = Text + Chr$(ASCII_TAB)
   ' Next i
   ' Text = Text + Chr$(ASCII_CR) + Chr$(ASCII_LF)
  'Next j

  GetAscii = text

End Function

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
Function GetIndex(Tag As String)
  ' Given an Tag string (of the form "<data source name> <#>")
  ' returns the appropriate index in the Connection array
  ' Returns SQL_ERROR if no such connection exists
  ' (Which is not necessarily a bad thing)
  Dim i As Integer

  For i = 1 To MaxConnections
    If Connection.Status = Active And Connection.Tag = Tag Then
      GetIndex = i
      Exit Function
    End If
  Next i
  GetIndex = SQL_ERROR

End Function

'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
Function GetVisibleAscii(ByVal Headers As Integer) As String
  ' Like GetAscii, but returns contents of the visible portion of
  ' the grid buffer.  Partially obscured entries are also printed.
  
  'GetVisibleAscii = GetAscii(Headers, QueryForm.DataGrid.SelStartRow, QueryForm.DataGrid.SelEndRow, QueryForm.DataGrid.SelStartCol, QueryForm.DataGrid.SelEndCol)
 
End Function

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
Sub SetAllocSize(sz As Integer)
  ' Set the grid buffer size

  AllocSize = sz

End Sub

