Attribute VB_Name = "odbext_g"
'
'|========================================================================|
'| ODBC Global Extended Definitions                                       |
'|========================================================================|
'
'  Date/Time/Timestamp Structs
'
Type DATE_STRUCT
  year      As Integer
  month     As Integer
  day       As Integer
End Type

Type TIME_SRUCT
  hour      As Integer
  minute    As Integer
  second    As Integer
End Type

Type TIMESTAMP_STRUCT
  year      As Integer
  month     As Integer
  day       As Integer
  hour      As Integer
  minute    As Integer
  second    As Integer
  fraction  As Long
End Type

' Level 1 Definitions/Functions
' Additional return codes
'
Global Const SQL_STILL_EXECUTING = 2

' SQL extended datatypes
'
Global Const SQL_DATE = 9
Global Const SQL_TIME = 10
Global Const SQL_TIMESTAMP = 11
Global Const SQL_LONGVARCHAR = -1
Global Const SQL_BINARY = -2
Global Const SQL_VARBINARY = -3
Global Const SQL_LONGVARBINARY = -4
Global Const SQL_BIGINT = -5
Global Const SQL_TINYINT = -6
Global Const SQL_BIT = -7

' C datatype to SQL datatype mapping
'
Global Const SQL_C_DATE = SQL_DATE
Global Const SQL_C_TIME = SQL_TIME
Global Const SQL_C_TIMESTAMP = SQL_TIMESTAMP
Global Const SQL_C_BINARY = SQL_BINARY
Global Const SQL_C_BIT = SQL_BIT
Global Const SQL_C_TINYINT = SQL_TINYINT

Global Const SQL_ALL_TYPES = 0

' Access modes
'
Global Const SQL_MODE_READ_WRITE = 0
Global Const SQL_MODE_READ_ONLY = 1

' Options for SQLDriverConnect
'
Global Const SQL_DRIVER_NOPROMPT = 0
Global Const SQL_DRIVER_COMPLETE = 1
Global Const SQL_DRIVER_PROMPT = 2
Global Const SQL_DRIVER_COMPLETE_REQUIRED = 3

' Special return values for SQLGetData
'
Global Const SQL_NO_TOTAL = -4

' Defines for SQLGetFunctions
' Core Functions
'
Global Const SQL_API_SQLALLOCCONNECT = 1
Global Const SQL_API_SQLALLOCENV = 2
Global Const SQL_API_SQLALLOCSTMT = 3
Global Const SQL_API_SQLBINDCOL = 4
Global Const SQL_API_SQLCANCEL = 5
Global Const SQL_API_SQLCOLATTRIBUTES = 6
Global Const SQL_API_SQLCONNECT = 7
Global Const SQL_API_SQLDESCRIBECOL = 8
Global Const SQL_API_SQLDISCONNECT = 9
Global Const SQL_API_SQLERROR = 10
Global Const SQL_API_SQLEXECDIRECT = 11
Global Const SQL_API_SQLEXECUTE = 12
Global Const SQL_API_SQLFETCH = 13
Global Const SQL_API_SQLFREECONNECT = 14
Global Const SQL_API_SQLFREEENV = 15
Global Const SQL_API_SQLFREESTMT = 16
Global Const SQL_API_SQLGETCURSORNAME = 17
Global Const SQL_API_SQLNUMRESULTCOLS = 18
Global Const SQL_API_SQLPREPARE = 19
Global Const SQL_API_SQLROWCOUNT = 20
Global Const SQL_API_SQLSETCURSORNAME = 21
Global Const SQL_API_SQLSETPARAM = 22
Global Const SQL_API_SQLTRANSACT = 23
Global Const SQL_NUM_FUNCTIONS = 23
Global Const SQL_EXT_API_START = 40
Global Const SQL_API_SQLCOLUMNS = 40

' Level 1 Functions
'
Global Const SQL_API_SQLDRIVERCONNECT = 41
Global Const SQL_API_SQLGETCONNECTOPTION = 42
Global Const SQL_API_SQLGETDATA = 43
Global Const SQL_API_SQLGETFUNCTIONS = 44
Global Const SQL_API_SQLGETINFO = 45
Global Const SQL_API_SQLGETSTMTOPTION = 46
Global Const SQL_API_SQLGETTYPEINFO = 47
Global Const SQL_API_SQLPARAMDATA = 48
Global Const SQL_API_SQLPUTDATA = 49
Global Const SQL_API_SQLSETCONNECTOPTION = 50
Global Const SQL_API_SQLSETSTMTOPTION = 51
Global Const SQL_API_SQLSPECIALCOLUMNS = 52
Global Const SQL_API_SQLSTATISTICS = 53
Global Const SQL_API_SQLTABLES = 54

' Level 2 Functions
'
Global Const SQL_API_SQLBROWSECONNECT = 55
Global Const SQL_API_SQLCOLUMNPRIVILEGES = 56
Global Const SQL_API_SQLDATASOURCES = 57
Global Const SQL_API_SQLDESCRIBEPARAM = 58
Global Const SQL_API_SQLEXTENDEDFETCH = 59
Global Const SQL_API_SQLFOREIGNKEYS = 60
Global Const SQL_API_SQLMORERESULTS = 61
Global Const SQL_API_SQLNATIVESQL = 62
Global Const SQL_API_SQLNUMPARAMS = 63
Global Const SQL_API_SQLPARAMOPTIONS = 64
Global Const SQL_API_SQLPRIMARYKEYS = 65
Global Const SQL_API_SQLPROCEDURECOLUMNS = 66
Global Const SQL_API_SQLPROCEDURES = 67
Global Const SQL_API_SQLSETPOS = 68
Global Const SQL_API_SQLSETSCROLLOPTIONS = 69
Global Const SQL_API_SQLTABLEPRIVILEGES = 70
Global Const SQL_EXT_API_LAST = 70

Global Const SQL_NUM_EXTENSIONS = (SQL_EXT_API_LAST - SQL_EXT_API_START + 1)

' Defines for SQLGetInfo
'
Global Const SQL_INFO_FIRST = 0
Global Const SQL_ACTIVE_CONNECTIONS = 0
Global Const SQL_ACTIVE_STATEMENTS = 1
Global Const SQL_DATA_SOURCE_NAME = 2
Global Const SQL_DRIVER_HDBC = 3
Global Const SQL_DRIVER_HENV = 4
Global Const SQL_DRIVER_HSTMT = 5
Global Const SQL_DRIVER_NAME = 6
Global Const SQL_DRIVER_VER = 7
Global Const SQL_FETCH_DIRECTION = 8
Global Const SQL_ODBC_API_CONFORMANCE = 9
Global Const SQL_ODBC_VER = 10
Global Const SQL_ROW_UPDATES = 11
Global Const SQL_ODBC_SAG_CLI_CONFORMANCE = 12
Global Const SQL_SERVER_NAME = 13
Global Const SQL_SEARCH_PATTERN_ESCAPE = 14
Global Const SQL_ODBC_SQL_CONFORMANCE = 15

Global Const SQL_DATABASE_NAME = 16
Global Const SQL_DBMS_NAME = 17
Global Const SQL_DBMS_VER = 18

Global Const SQL_ACCESSIBLE_TABLES = 19
Global Const SQL_ACCESSIBLE_PROCEDURES = 20
Global Const SQL_PROCEDURES = 21
Global Const SQL_CONCAT_NULL_BEHAVIOR = 22
Global Const SQL_CURSOR_COMMIT_BEHAVIOR = 23
Global Const SQL_CURSOR_ROLLBACK_BEHAVIOR = 24
Global Const SQL_DATA_SOURCE_READ_ONLY = 25
Global Const SQL_DEFAULT_TXN_ISOLATION = 26
Global Const SQL_EXPRESSIONS_IN_ORDERBY = 27
Global Const SQL_IDENTIFIER_CASE = 28
Global Const SQL_IDENTIFIER_QUOTE_CHAR = 29
Global Const SQL_MAX_COLUMN_NAME_LEN = 30
Global Const SQL_MAX_CURSOR_NAME_LEN = 31
Global Const SQL_MAX_OWNER_NAME_LEN = 32
Global Const SQL_MAX_PROCEDURE_NAME_LEN = 33
Global Const SQL_MAX_QUALIFIER_NAME_LEN = 34
Global Const SQL_MAX_TABLE_NAME_LEN = 35
Global Const SQL_MULT_RESULT_SETS = 36
Global Const SQL_MULTIPLE_ACTIVE_TXN = 37
Global Const SQL_OUTER_JOINS = 38
Global Const SQL_OWNER_TERM = 39
Global Const SQL_PROCEDURE_TERM = 40
Global Const SQL_QUALIFIER_NAME_SEPARATOR = 41
Global Const SQL_QUALIFIER_TERM = 42
Global Const SQL_SCROLL_CONCURRENCY = 43
Global Const SQL_SCROLL_OPTIONS = 44
Global Const SQL_TABLE_TERM = 45
Global Const SQL_TXN_CAPABLE = 46
Global Const SQL_USER_NAME = 47

Global Const SQL_CONVERT_FUNCTIONS = 48
Global Const SQL_NUMERIC_FUNCTIONS = 49
Global Const SQL_STRING_FUNCTIONS = 50
Global Const SQL_SYSTEM_FUNCTIONS = 51
Global Const SQL_TIMEDATE_FUNCTIONS = 52

Global Const SQL_CONVERT_BIGINT = 53
Global Const SQL_CONVERT_BINARY = 54
Global Const SQL_CONVERT_BIT = 55
Global Const SQL_CONVERT_CHAR = 56
Global Const SQL_CONVERT_DATE = 57
Global Const SQL_CONVERT_DECIMAL = 58
Global Const SQL_CONVERT_DOUBLE = 59
Global Const SQL_CONVERT_FLOAT = 60
Global Const SQL_CONVERT_INTEGER = 61
Global Const SQL_CONVERT_LONGVARCHAR = 62
Global Const SQL_CONVERT_NUMERIC = 63
Global Const SQL_CONVERT_REAL = 64
Global Const SQL_CONVERT_SMALLINT = 65
Global Const SQL_CONVERT_TIME = 66
Global Const SQL_CONVERT_TIMESTAMP = 67
Global Const SQL_CONVERT_TINYINT = 68
Global Const SQL_CONVERT_VARBINARY = 69
Global Const SQL_CONVERT_VARCHAR = 70
Global Const SQL_CONVERT_LONGVARBINARY = 71

Global Const SQL_TXN_ISOLATION_OPTION = 72
Global Const SQL_ODBC_SQL_OPT_IEF = 73

Global Const SQL_INFO_LAST = 73
Global Const SQL_INFO_DRIVER_START = 1000

' "SQL_CONVERT_" return value bitmasks
'
Global Const SQL_CVT_CHAR = &H1&
Global Const SQL_CVT_NUMERIC = &H2&
Global Const SQL_CVT_DECIMAL = &H4&
Global Const SQL_CVT_INTEGER = &H8&
Global Const SQL_CVT_SMALLINT = &H10&
Global Const SQL_CVT_FLOAT = &H20&
Global Const SQL_CVT_REAL = &H40&
Global Const SQL_CVT_DOUBLE = &H80&
Global Const SQL_CVT_VARCHAR = &H100&
Global Const SQL_CVT_LONGVARCHAR = &H200&
Global Const SQL_CVT_BINARY = &H400&
Global Const SQL_CVT_VARBINARY = &H800&
Global Const SQL_CVT_BIT = &H1000&
Global Const SQL_CVT_TINYINT = &H2000&
Global Const SQL_CVT_BIGINT = &H4000&
Global Const SQL_CVT_DATE = &H8000&
Global Const SQL_CVT_TIME = &H10000
Global Const SQL_CVT_TIMESTAMP = &H20000
Global Const SQL_CVT_LONGVARBINARY = &H40000


' Conversion functions
'
Global Const SQL_FN_CVT_CONVERT = &H1&

' String functions
'
Global Const SQL_FN_STR_CONCAT = &H1&
Global Const SQL_FN_STR_INSERT = &H2&
Global Const SQL_FN_STR_LEFT = &H4&
Global Const SQL_FN_STR_LTRIM = &H8&
Global Const SQL_FN_STR_LENGTH = &H10&
Global Const SQL_FN_STR_LOCATE = &H20&
Global Const SQL_FN_STR_LCASE = &H40&
Global Const SQL_FN_STR_REPEAT = &H80&
Global Const SQL_FN_STR_REPLACE = &H100&
Global Const SQL_FN_STR_RIGHT = &H200&
Global Const SQL_FN_STR_RTRIM = &H400&
Global Const SQL_FN_STR_SUBSTRING = &H800&
Global Const SQL_FN_STR_UCASE = &H1000&
Global Const SQL_FN_STR_ASCII = &H2000&
Global Const SQL_FN_STR_CHAR = &H4000&

' Numeric functions
'
Global Const SQL_FN_NUM_ABS = &H1&
Global Const SQL_FN_NUM_ACOS = &H2&
Global Const SQL_FN_NUM_ASIN = &H4&
Global Const SQL_FN_NUM_ATAN = &H8&
Global Const SQL_FN_NUM_ATAN2 = &H10&
Global Const SQL_FN_NUM_CEILING = &H20&
Global Const SQL_FN_NUM_COS = &H40&
Global Const SQL_FN_NUM_COT = &H80&
Global Const SQL_FN_NUM_EXP = &H100&
Global Const SQL_FN_NUM_FLOOR = &H200&
Global Const SQL_FN_NUM_LOG = &H400&
Global Const SQL_FN_NUM_MOD = &H800&
Global Const SQL_FN_NUM_SIGN = &H1000&
Global Const SQL_FN_NUM_SIN = &H2000&
Global Const SQL_FN_NUM_SQRT = &H4000&
Global Const SQL_FN_NUM_TAN = &H8000&
Global Const SQL_FN_NUM_PI = &H10000
Global Const SQL_FN_NUM_RAND = &H20000

' Time/date functions
'
Global Const SQL_FN_TD_NOW = &H1&
Global Const SQL_FN_TD_CURDATE = &H2&
Global Const SQL_FN_TD_DAYOFMONTH = &H4&
Global Const SQL_FN_TD_DAYOFWEEK = &H8&
Global Const SQL_FN_TD_DAYOFYEAR = &H10&
Global Const SQL_FN_TD_MONTH = &H20&
Global Const SQL_FN_TD_QUARTER = &H40&
Global Const SQL_FN_TD_WEEK = &H80&
Global Const SQL_FN_TD_YEAR = &H100&
Global Const SQL_FN_TD_CURTIME = &H200&
Global Const SQL_FN_TD_HOUR = &H400&
Global Const SQL_FN_TD_MINUTE = &H800&
Global Const SQL_FN_TD_SECOND = &H1000&

' System functions
'
Global Const SQL_FN_SYS_USERNAME = &H1&
Global Const SQL_FN_SYS_DBNAME = &H2&
Global Const SQL_FN_SYS_IFNULL = &H4&

' Scroll option masks
'
Global Const SQL_SO_FORWARD_ONLY = &H1&
Global Const SQL_SO_KEYSET_DRIVEN = &H2&
Global Const SQL_SO_DYNAMIC = &H4&
Global Const SQL_SO_MIXED = &H8&

' Scroll concurrency option masks
'
Global Const SQL_SCCO_READ_ONLY = &H1&
Global Const SQL_SCCO_LOCK = &H2&
Global Const SQL_SCCO_OPT_TIMESTAMP = &H4&
Global Const SQL_SCCO_OPT_VALUES = &H8&

' Fetch direction option masks
'
Global Const SQL_FD_FETCH_NEXT = &H1&
Global Const SQL_FD_FETCH_FIRST = &H2&
Global Const SQL_FD_FETCH_LAST = &H4&
Global Const SQL_FD_FETCH_PREV = &H8&
Global Const SQL_FD_FETCH_ABSOLUTE = &H10&
Global Const SQL_FD_FETCH_RELATIVE = &H20&
Global Const SQL_FD_FETCH_RESUME = &H40&

' Transaction isolation option masks
'
Global Const SQL_TXN_READ_UNCOMMITTED = &H1&
Global Const SQL_TXN_READ_COMMITTED = &H2&
Global Const SQL_TXN_REPEATABLE_READ = &H4&
Global Const SQL_TXN_SERIALIZABLE = &H8&
Global Const SQL_TXN_VERSIONING = &H10&

' options for SQLGetStmtOption/SQLSetStmtOption
'
Global Const SQL_QUERY_TIMEOUT = 0
Global Const SQL_MAX_ROWS = 1
Global Const SQL_NOSCAN = 2
Global Const SQL_MAX_LENGTH = 3
Global Const SQL_ASYNC_ENABLE = 4
Global Const SQL_BIND_TYPE = 5

Global Const SQL_BIND_BY_COLUMN = 0

' Suboption for SQL_BIND_TYPE
' options for SQLSetConnectOption/SQLGetConnectOption
'
Global Const SQL_ACCESS_MODE = 101
Global Const SQL_AUTOCOMMIT = 102
Global Const SQL_LOGIN_TIMEOUT = 103
Global Const SQL_OPT_TRACE = 104
Global Const SQL_OPT_TRACEFILE = 105
Global Const SQL_TRANSLATE_DLL = 106
Global Const SQL_TRANSLATE_OPTION = 107
Global Const SQL_TXN_ISOLATION = 108
Global Const SQL_CONNECT_OPT_DRVR_START = 1000
'#if (ODBCVER >= 0x0200)
Global Const SQL_CURSOR_TYPE = 6
Global Const SQL_CONCURRENCY = 7
Global Const SQL_KEYSET_SIZE = 8
Global Const SQL_ROWSET_SIZE = 9
Global Const SQL_SIMULATE_CURSOR = 10
Global Const SQL_RETRIEVE_DATA = 11
Global Const SQL_USE_BOOKMARKS = 12
Global Const SQL_GET_BOOKMARK = 13 '/* GetStmtOption Only */
Global Const SQL_ROW_NUMBER = 14 '/* GetStmtOption Only */
Global Const SQL_STMT_OPT_MAX = 14

Global Const SQL_OPT_TRACE_OFF = 0
Global Const SQL_OPT_TRACE_ON = 1


'/* SQL_AUTOCOMMIT options */
Global Const SQL_AUTOCOMMIT_OFF = 0
Global Const SQL_AUTOCOMMIT_ON = 1
Global Const SQL_AUTOCOMMIT_DEFAULT = SQL_AUTOCOMMIT_ON


' Column types and scopes in SQLSpecialColumns.
'
Global Const SQL_BEST_ROWID = 1
Global Const SQL_ROWVER = 2

Global Const SQL_SCOPE_CURROW = 0
Global Const SQL_SCOPE_TRANSACTION = 1
Global Const SQL_SCOPE_SESSION = 2

' Level 2 Functions
'
' SQLExtendedFetch "fFetchType" values
'
Global Const SQL_FETCH_NEXT = 1
Global Const SQL_FETCH_FIRST = 2
Global Const SQL_FETCH_LAST = 3
Global Const SQL_FETCH_PREV = 4
Global Const SQL_FETCH_ABSOLUTE = 5
Global Const SQL_FETCH_RELATIVE = 6
Global Const SQL_FETCH_RESUME = 7

' SQLExtendedFetch "rgfRowStatus" element values
'
Global Const SQL_ROW_SUCCESS = 0
Global Const SQL_ROW_DELETED = 1
Global Const SQL_ROW_UPDATED = 2
Global Const SQL_ROW_NOROW = 3

' Defines for SQLForeignKeys (returned in result set)
'
Global Const SQL_CASCADE = 0
Global Const SQL_RESTRICT = 1
Global Const SQL_SET_NULL = 2

' Defines for SQLProcedureColumns (returned in the result set)
'
Global Const SQL_PARAM_TYPE_UNKNOWN = 0
Global Const SQL_PARAM_INPUT = 1
Global Const SQL_PARAM_INPUT_OUTPUT = 2
Global Const SQL_RESULT_COL = 3
Global Const SQL_PARAM_OUTPUT = 4         'added for bindparam

' Defines for SQLSetScrollOptions
'
Global Const SQL_CONCUR_READ_ONLY = 1
Global Const SQL_CONCUR_LOCK = 2
Global Const SQL_CONCUR_TIMESTAMP = 3
Global Const SQL_CONCUR_VALUES = 4

Global Const SQL_SCROLL_FORWARD_ONLY = 0
Global Const SQL_SCROLL_KEYSET_DRIVEN = -1
Global Const SQL_SCROLL_DYNAMIC = -2

' Defines for SQLStatistics
'
Global Const SQL_INDEX_UNIQUE = 0
Global Const SQL_INDEX_ALL = 1
Global Const SQL_ENSURE = 1
Global Const SQL_QUICK = 0

' Defines for SQLStatistics (returned in the result set)
'
Global Const SQL_TABLE_STAT = 0
Global Const SQL_INDEX_CLUSTERED = 1
Global Const SQL_INDEX_HASHED = 2
Global Const SQL_INDEX_OTHER = 3

' Defines for SQLSetPos
'
Global Const SQL_ENTIRE_ROWSET = 0
