VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "SrcPF"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Description = "Work with Source PFs via SQL"
Attribute VB_Ext_KEY = "SavedWithClassBuilder" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
'*********************************************************************
'/* COPYRIGHTS:                                                      */
'/*                                                                  */
'/*   This module contains code made available by IBM Corporation on */
'/* an AS IS basis.  Any one receiving the module is  considered  to */
'/* be  licensed under IBM copyrights to use the IBM-provided source */
'/* code in any way he or  she  deems  fit,  including  copying  it, */
'/* compiling  it,  modifying  it,  and  redistributing  it, with or */
'/* without modifications.  No license  under  any  IBM  patents  or */
'/* patent  applications  is  to  be  implied  from  this  copyright */
'/* license.                                                         */
'/*                                                                  */
'/*   A user of the module should understand that IBM cannot provide */
'/* technical support for the module and will not be responsible for */
'/* any consequences of use of the program.                          */
'/*                                                                  */
'/*   Any notice,  including this one, are not to  be  removed  from */
'/* the module with out the prior written consent of IBM.            */
'/*                                                                  */
'*********************************************************************
'This class uploads source PF memebers using ODBC.  It will:
   '1) Create the specified SRCPF if it does not already exist
   '2) Create the member if it does not already exist
   '3) Clear the member if *REPLACE
   '4) OVRDBF to the member
   '5) Upload the specified records to the member:
   '     If ADD will need to determine last sequence number
   '     Use either file name or string array as source
   '6) DLTOVR
'Dependancies:
   'It uses the RMTCMD function from another module (but this could be copied in)
'Limitations:
   'Library must be specified (to avoid *CURLIB <> Default collection)
      '  When mixing native commands (CRTSRCPF)and SQL keep in mind that
      'Default collection is not the same as current library.  Unless you
      'switch over to *SYS naming you cannot count on knowing what library was
      'used for *CURLIB.  There isn't a simple method to return either
      'current library or default collection that I can think of.
'TODOs:
   'If inserting really large files use block insert instead.
   'Might want to return error collection  or raise error instead of putting up msgbox
   'Need to add *ADD option
   'Add a download option
'Example:
   '   Set DBMONLF = New SrcPF
   '   DBMONLF.ODBC_hdbc = ghDbc
   '   DBMONLF.SrcPFFileName = txtFileName
   '   DBMONLF.SrcPFLibName = txtLibName
   '   DBMONLF.SrcPFMbrName = LFNames(I)
   '   DBMONLF.SrcPFMbrType = "LF"
   '   DBMONLF.SourceType = SrcPF_PCfile       'upload source is PC File
   '   DBMONLF.MBROPT = SrcPF_REPLACE
   '   DBMONLF.PCFileName = PathName & LFNames(I) & ".txt"  'PC file to upload
   '   rc = DBMONLF.UploadSrc
   '   'You can compile the source member using calls to QCMDEXC

Option Explicit

'Events
'Allow caller to see/modify input record read in from a file
Public Event ModifyRecord(NextLine As String)
   'To use: Declare the variable as Private WithEvents xxxx As SrcPF
   'Add the event function:         Private Sub xxxx_ModifyRecord(InputRec As String)

'local variable(s) to hold property value(s)
Private mvarODBC_hdbc As Long                'ODBC Connection handle to use on upload
Private mvarSrcPFFileName As String          'Source PF Name
Private mvarSrcPFLibName As String           'Source PF Library
Private mvarSrcPFMbrName As String           'Source Member for upload
Private mvarSrcPFMbrType As String           'Source PF Member Type (i.e. LF, PF, ...)
Private mvarRecLen As Long                   'record length of source PF
Private mvarMBROPT As MBROPTEnum             '*ADD or *REPLACE
Private mvarSourceType As FromSourceEnum     'Where to upload from: Disk or string array
Private mvarPCFileName As String             '    PC file name to upload
Private mvarInputArray As Variant            '    String array to upload

'Enums for public properties
Public Enum MBROPTEnum
   SrcPF_REPLACE = 1
   SrcPF_ADD = 2
End Enum
Public Enum FromSourceEnum
   SrcPF_PCfile = 1
   SrcPF_ArrayOfStrings = 2
End Enum


Public Property Let ODBC_hdbc(ByVal vData As Long)
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.ODBC_hdbc = 5
    mvarODBC_hdbc = vData
End Property


Public Property Get ODBC_hdbc() As Long
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.ODBC_hdbc
    ODBC_hdbc = mvarODBC_hdbc
End Property



Public Property Let SrcPFMbrType(ByVal vData As String)
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.SrcPFMbrType = 5
    mvarSrcPFMbrType = vData
End Property


Public Property Get SrcPFMbrType() As String
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.SrcPFMbrType
    SrcPFMbrType = mvarSrcPFMbrType
End Property

Public Property Let MBROPT(ByVal vData As MBROPTEnum)
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.MBROPT = 5
    mvarMBROPT = vData
End Property


Public Property Get MBROPT() As MBROPTEnum
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.MBROPT
        MBROPT = mvarMBROPT
End Property

Public Property Let SrcPFMbrName(ByVal vData As String)
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.mvarSrcPFMbrName = 5
    mvarSrcPFMbrName = vData
End Property


Public Property Get SrcPFMbrName() As String
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.mvarSrcPFMbrName
    SrcPFMbrName = mvarSrcPFMbrName
End Property


Public Property Let SrcPFRecLen(ByVal vData As Long)
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.RecLen = 5
    mvarRecLen = vData
End Property


Public Property Get SrcPFRecLen() As Long
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.RecLen
    SrcPFRecLen = mvarRecLen
End Property


Public Function UploadSrc(Optional InputData As Variant) As Boolean
Attribute UploadSrc.VB_UserMemId = 0
   
   Dim S As String
   Dim InRec As String
   Dim abData() As Byte
   Dim hStmt As Long
   Dim I As Long
   Dim LineNum As Integer
   Dim SrcDat As Integer
   Dim pcbSQLNTS As Long
   Dim pcbSQLDftParam As Long
   
   pcbSQLNTS = SQL_NTS
   pcbSQLDftParam = SQL_DEFAULT_PARAM
   
   'Check for valid input
   If Len(mvarSrcPFMbrName) = 0 Then
      MsgBox " you must specify a member name", vbExclamation, gAppName
      UploadSrc = False
      Exit Function
   End If
   If Len(mvarSrcPFLibName) = 0 Or InStr(1, mvarSrcPFLibName, "*CURLIB", vbTextCompare) <> 0 Then
      S = "You must specify a library name.  Special values like *CURLIB are " & _
            "not allowed."
      MsgBox S, vbExclamation, gAppName
      UploadSrc = False
      Exit Function
   End If
   If mvarSourceType = SrcPF_PCfile Then
      'Test to make sure file exists...
      On Error Resume Next
      I = FileLen(mvarPCFileName)
      If I = 0 Then
         S = "Specified file, " & mvarPCFileName & ", does not exist or is empty.  Err " & _
            Str(Err.Number) & Err.Description & vbCrLf & vbCrLf & "Upload failed."
         MsgBox S, vbInformation, gAppName
         UploadSrc = False
         Exit Function
      End If
   End If
   
   rc = SQLAllocStmt(mvarODBC_hdbc, hStmt)
   If (rc <> SQL_SUCCESS And rc <> SQL_SUCCESS_WITH_INFO) Then
      PrintError mvarODBC_hdbc, 0
      UploadSrc = False
      Exit Function
   End If
   
   '*******************************************************************
   'Create the SRCPF if needed
   '*******************************************************************
   S = "CRTSRCPF FILE(" & mvarSrcPFLibName & "/" & mvarSrcPFFileName & ") "
   rc = RmtCmd(S, True)    'assume bad return code is already exists
   
   'Create the new member (if it doesn't exist)
   S = "ADDPFM FILE(" & mvarSrcPFLibName & "/" & mvarSrcPFFileName & _
      ") MBR(" & mvarSrcPFMbrName & ") SRCTYPE(" & mvarSrcPFMbrType & ")"
   rc = RmtCmd(S, True)    'assume bad return code is already exists
   
   'Set override to the new member
   S = "OVRDBF FILE(" & mvarSrcPFFileName & ") TOFILE(*FILE) MBR(" & _
       mvarSrcPFMbrName & ") OVRSCOPE(*JOB)"
   rc = RmtCmd(S)    'This failing should catch errors on previous commands
   
   
   'If *REPLACE clear the member first
   'If InStr(1, mvarMBROPT, "*REPLACE", vbTextCompare) > 0 Then
   If mvarMBROPT = SrcPF_REPLACE Then
      S = "CLRPFM FILE(" & mvarSrcPFLibName & "/" & mvarSrcPFFileName & _
         ") MBR(" & mvarSrcPFMbrName & ") "
      rc = RmtCmd(S)
   Else
      'TODO:  Select recnum from xxxx order by recnum (descending)
      ' fetch first rec to get start for sequence number to use on append.
      '  or (hack) pick a big starting record number and hope
   End If
   
      
   
   '*******************************************************************
   'Insert the data
   '*******************************************************************
   S = "INSERT INTO " & Trim(mvarSrcPFLibName) & "." & _
         Trim(mvarSrcPFFileName) & " VALUES(?, ?, ?)"
   rc = SQLPrepare(hStmt, S, SQL_NTS)
   If (Not (rc = SQL_SUCCESS Or rc = SQL_SUCCESS_WITH_INFO)) Then GoTo errSQLExecute
   ReDim abData(mvarRecLen)      'Size for max record length + null
   rc = SQLBindParameter(hStmt, 1, SQL_PARAM_INPUT, SQL_C_SHORT, SQL_NUMERIC, _
                         6, 2, LineNum, 0, pcbSQLDftParam)
   rc = SQLBindParameter(hStmt, 2, SQL_PARAM_INPUT, SQL_C_SHORT, SQL_NUMERIC, _
                         8, 0, SrcDat, 0, pcbSQLDftParam)
   rc = SQLBindParameter(hStmt, 3, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_CHAR, _
                         mvarRecLen, 0, abData(0), Sizeof(abData), pcbSQLNTS)
   If (rc = SQL_ERROR) Then GoTo errSQLExecute
   
   If mvarSourceType = SrcPF_PCfile Then
      '********   USE ascii crlf delimited FILE as input source *************
      Open mvarPCFileName For Input As #1
      LineNum = 0
      Do While Not EOF(1)
         Line Input #1, S                    'Read in next record
         LineNum = LineNum + 1
         RaiseEvent ModifyRecord(S)          'Chance for caller to modify input
         Call String2Byte(S, abData)
         rc = SQLExecute(hStmt)
         If (rc = SQL_ERROR) Then GoTo errSQLExecute
         If LineNum Mod 100 = 0 Then DoEvents
      Loop
      Close #1
   Else
      '************  Use array of String as input ******************************
      For I = LBound(mvarInputArray) To UBound(mvarInputArray)
         LineNum = I * 10
         S = mvarInputArray(I)
         Call String2Byte(S, abData)
         rc = SQLExecute(hStmt)
         If (rc = SQL_ERROR) Then GoTo errSQLExecute
         If I Mod 100 = 0 Then DoEvents
      Next I
   End If
   
   
   'Delete the override
   rc = RmtCmd("DLTOVR FILE(*ALL) LVL(*JOB)")
   
   rc = SQLFreeStmt(hStmt, SQL_DROP)
   UploadSrc = True
   Exit Function
   
errSQLExecute:
   'Delete the override
   rc = RmtCmd("DLTOVR FILE(*ALL) LVL(*JOB)", True)
   PrintError mvarODBC_hdbc, hStmt
   rc = SQLFreeStmt(hStmt, SQL_DROP)
   UploadSrc = False
   
End Function



Public Property Let InputArray(ByVal vData As Variant)
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.InputArray = 5
    mvarInputArray = vData
End Property


Public Property Set InputArray(ByVal vData As Object)
'used when assigning an Object to the property, on the left side of a Set statement.
'Syntax: Set x.InputArray = Form1
    Set mvarInputArray = vData
End Property


Public Property Get InputArray() As Variant
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.InputArray
    If IsObject(mvarInputArray) Then
        Set InputArray = mvarInputArray
    Else
        InputArray = mvarInputArray
    End If
End Property



Public Property Let PCFileName(ByVal vData As String)
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.PCFileName = 5
    mvarPCFileName = vData
End Property


Public Property Get PCFileName() As String
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.PCFileName
    PCFileName = mvarPCFileName
End Property



Public Property Let SourceType(ByVal vData As FromSourceEnum)
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.SourceType = 5
    mvarSourceType = vData
End Property


Public Property Get SourceType() As FromSourceEnum
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.SourceType
    SourceType = mvarSourceType
End Property



Public Property Let SrcPFLibName(ByVal vData As String)
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.SrcPFLibName = 5
    mvarSrcPFLibName = vData
End Property


Public Property Get SrcPFLibName() As String
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.SrcPFLibName
    SrcPFLibName = mvarSrcPFLibName
End Property



Public Property Let SrcPFFileName(ByVal vData As String)
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.SrcPFFileName = 5
    mvarSrcPFFileName = vData
End Property


Public Property Get SrcPFFileName() As String
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.SrcPFFileName
    SrcPFFileName = mvarSrcPFFileName
End Property



Private Sub Class_Initialize()
   mvarRecLen = 92         'Default record length of Source PF
   mvarSrcPFLibName = "*CURLIB"
   mvarSrcPFFileName = "DBMONSRC"
   mvarMBROPT = SrcPF_REPLACE
   mvarSourceType = SrcPF_PCfile

End Sub



