Attribute VB_Name = "odbcinst"
'Derived from ODBCINST.H - part of the Microsoft ODBC SDK (Platform SDK)

'  Prototypes for ODBCCP32.DLL

'  Constants ---------------------------------------------------------------
'  SQLConfigDataSource request flags
Global Const ODBC_ADD_DSN = 1                   '  Add data source
Global Const ODBC_CONFIG_DSN = 2                '  Configure (edit) data source
Global Const ODBC_REMOVE_DSN = 3                '  Remove data source

'#if (ODBCVER >= 0x0250)
Global Const ODBC_ADD_SYS_DSN = 4              '  add a system DSN
Global Const ODBC_CONFIG_SYS_DSN = 5        '  Configure a system DSN
Global Const ODBC_REMOVE_SYS_DSN = 6        '  remove a system DSN
'#if (ODBCVER >= 0x0300)
Global Const ODBC_REMOVE_DEFAULT_DSN = 7        '  remove the default DSN
'#End If ' /* ODBCVER >= 0x0300 */

'  install request flags
Global Const ODBC_INSTALL_INQUIRY = 1
Global Const ODBC_INSTALL_COMPLETE = 2

'  config driver flags
Global Const ODBC_INSTALL_DRIVER = 1
Global Const ODBC_REMOVE_DRIVER = 2
Global Const ODBC_CONFIG_DRIVER = 3
Global Const ODBC_CONFIG_DRIVER_MAX = 100
'#End If

'  SQLGetConfigMode and SQLSetConfigMode flags
'#if (ODBCVER >= 0x0300)
Global Const ODBC_BOTH_DSN = 0
Global Const ODBC_USER_DSN = 1
Global Const ODBC_SYSTEM_DSN = 2
'#End If ' /* ODBCVER >= 0x0300 */

'  SQLInstallerError code
'#if (ODBCVER >= 0x0300)
Global Const ODBC_ERROR_GENERAL_ERR = 1
Global Const ODBC_ERROR_INVALID_BUFF_LEN = 2
Global Const ODBC_ERROR_INVALID_HWND = 3
Global Const ODBC_ERROR_INVALID_STR = 4
Global Const ODBC_ERROR_INVALID_REQUEST_TYPE = 5
Global Const ODBC_ERROR_COMPONENT_NOT_FOUND = 6
Global Const ODBC_ERROR_INVALID_NAME = 7
Global Const ODBC_ERROR_INVALID_KEYWORD_VALUE = 8
Global Const ODBC_ERROR_INVALID_DSN = 9
Global Const ODBC_ERROR_INVALID_INF = 10
Global Const ODBC_ERROR_REQUEST_FAILED = 11
Global Const ODBC_ERROR_INVALID_PATH = 12
Global Const ODBC_ERROR_LOAD_LIB_FAILED = 13
Global Const ODBC_ERROR_INVALID_PARAM_SEQUENCE = 14
Global Const ODBC_ERROR_INVALID_LOG_FILE = 15
Global Const ODBC_ERROR_USER_CANCELED = 16
Global Const ODBC_ERROR_USAGE_UPDATE_FAILED = 17
Global Const ODBC_ERROR_CREATE_DSN_FAILED = 18
Global Const ODBC_ERROR_WRITING_SYSINFO_FAILED = 19
Global Const ODBC_ERROR_REMOVE_DSN_FAILED = 20
Global Const ODBC_ERROR_OUT_OF_MEM = 21
Global Const ODBC_ERROR_OUTPUT_STRING_TRUNCATED = 22
'#End If ' /* ODBCVER >= 0x0300 */

'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Declare Function SQLConfigDataSource Lib "ODBCCP32" ( _
               ByVal hwndParent As Long, _
               ByVal fRequest As Integer, _
               ByVal lpszDriver As String, _
               ByVal lpszAttributes As String) As Integer
               
Declare Function SQLManageDataSources Lib "ODBCCP32" (ByVal hwnd As Long) As Integer

Declare Function SQLGetPrivateProfileString Lib "ODBCCP32" ( _
                              ByVal lpszSection As String, _
                              ByVal lpszEntry As String, _
                              ByVal lpszDefault As String, _
                              ByRef lpszRetBuffer As Byte, _
                              ByVal cbRetBuffer As Long, _
                              ByVal szFileName As String) As Long


'#if (ODBCVER >=  0x0300)
Declare Function SQLInstallerError Lib "ODBCCP32" ( _
                     ByVal iError As Integer, _
                     ByRef fErrorCode As Long, _
                     ByVal lpszErrorMsg As String, _
                     ByVal cbErrorMsgMax As Integer, _
                     ByRef pcbErrorMsg As Integer) As Long


